"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Eq = exports.setHash = exports.modifyHash = exports.getHash = exports.setParams = exports.modifyParams = exports.getParams = exports.setPathname = exports.modifyPathname = exports.getPathname = exports.toString = exports.fromPathname = exports.fromStringO = exports.fromString = exports.toURLO = exports.toURL = exports.fromURL = exports.clone = exports.isURLPath = void 0;
const E = require("fp-ts/Either");
const Eq_ = require("fp-ts/Eq");
const O = require("fp-ts/Option");
const function_1 = require("fp-ts/function");
const Newtype_1 = require("./Newtype");
const URL = require("./URL");
const phonyBase = "https://urlpath.fp-ts-std.samhh.com";
const isURLPath = (u) => URL.isURL(u) && u.origin === phonyBase;
exports.isURLPath = isURLPath;
exports.clone = (0, Newtype_1.over)(URL.clone);
const fromURL = (x) => (0, function_1.pipe)(new globalThis.URL(x.href, phonyBase), (Newtype_1.pack));
exports.fromURL = fromURL;
const toURL = (f) => (baseUrl) => (x) => E.tryCatch(() => new globalThis.URL((0, exports.toString)(x), baseUrl), e => f(e));
exports.toURL = toURL;
const toURLO = (baseUrl) => (0, function_1.flow)((0, exports.toURL)(function_1.identity)(baseUrl), O.fromEither);
exports.toURLO = toURLO;
const fromString = (f) => (x) => (0, function_1.pipe)(E.tryCatch(() => {
    const y = new globalThis.URL(x, phonyBase);
    if (y.origin !== phonyBase)
        throw new TypeError("Failed to retain phony base URL");
    return y;
}, e => f(e)), E.map((Newtype_1.pack)));
exports.fromString = fromString;
exports.fromStringO = (0, function_1.flow)((0, exports.fromString)(function_1.identity), O.fromEither);
const fromPathname = (x) => {
    const y = new globalThis.URL("", phonyBase);
    y.pathname = x;
    return (0, Newtype_1.pack)(y);
};
exports.fromPathname = fromPathname;
exports.toString = (0, function_1.flow)(Newtype_1.unpack, x => x.pathname + x.search + x.hash);
exports.getPathname = (0, function_1.flow)(Newtype_1.unpack, URL.getPathname);
const modifyPathname = (f) => (0, Newtype_1.over)(URL.modifyPathname(f));
exports.modifyPathname = modifyPathname;
const setPathname = (x) => (0, Newtype_1.over)(URL.setPathname(x));
exports.setPathname = setPathname;
exports.getParams = (0, function_1.flow)(Newtype_1.unpack, URL.getParams);
const modifyParams = (f) => (0, Newtype_1.over)(URL.modifyParams(f));
exports.modifyParams = modifyParams;
const setParams = (x) => (0, Newtype_1.over)(URL.setParams(x));
exports.setParams = setParams;
exports.getHash = (0, function_1.flow)(Newtype_1.unpack, URL.getHash);
const modifyHash = (f) => (0, Newtype_1.over)(URL.modifyHash(f));
exports.modifyHash = modifyHash;
const setHash = (x) => (0, Newtype_1.over)(URL.setHash(x));
exports.setHash = setHash;
exports.Eq = Eq_.contramap(Newtype_1.unpack)(URL.Eq);
