import * as E from "fp-ts/Either";
import * as Eq_ from "fp-ts/Eq";
import * as O from "fp-ts/Option";
import { flow, identity, pipe } from "fp-ts/function";
import { over, pack, unpack } from "./Newtype";
import * as URL from "./URL";
const phonyBase = "https://urlpath.fp-ts-std.samhh.com";
export const isURLPath = (u) => URL.isURL(u) && u.origin === phonyBase;
export const clone = over(URL.clone);
export const fromURL = (x) => pipe(new globalThis.URL(x.href, phonyBase), (pack));
export const toURL = (f) => (baseUrl) => (x) => E.tryCatch(() => new globalThis.URL(toString(x), baseUrl), e => f(e));
export const toURLO = (baseUrl) => flow(toURL(identity)(baseUrl), O.fromEither);
export const fromString = (f) => (x) => pipe(E.tryCatch(() => {
    const y = new globalThis.URL(x, phonyBase);
    if (y.origin !== phonyBase)
        throw new TypeError("Failed to retain phony base URL");
    return y;
}, e => f(e)), E.map((pack)));
export const fromStringO = flow(fromString(identity), O.fromEither);
export const fromPathname = (x) => {
    const y = new globalThis.URL("", phonyBase);
    y.pathname = x;
    return pack(y);
};
export const toString = flow(unpack, x => x.pathname + x.search + x.hash);
export const getPathname = flow(unpack, URL.getPathname);
export const modifyPathname = (f) => over(URL.modifyPathname(f));
export const setPathname = (x) => over(URL.setPathname(x));
export const getParams = flow(unpack, URL.getParams);
export const modifyParams = (f) => over(URL.modifyParams(f));
export const setParams = (x) => over(URL.setParams(x));
export const getHash = flow(unpack, URL.getHash);
export const modifyHash = (f) => over(URL.modifyHash(f));
export const setHash = (x) => over(URL.setHash(x));
export const Eq = Eq_.contramap(unpack)(URL.Eq);
